cd      "E:\KURSER\PostReg\Version6\Exercises\Day4"

*start a log file 
capture log close
log using RegDayEx4.log,text replace

use obese.dta,clear
set scheme lean1
codebook,comp

generate age50=age-50
generate bmi25=bmi-25
generate sbphigh=(sbp>140) if !missing(sbp)
label var sbphigh "SBP >140"

logit sbphigh ib1.sex##c.age50 bmi25
logit,or

*Q1

*Q2
************************************************************************
regeq
************************************************************************
*Q3
twoway ///
(function  y=$b1*1 + $b2*(x-50) + $b3*1*(x-50) + $b4*(25-25) + $b0 ,range(age)  lco(red) lpa(1))  ///
(function  y=$b1*0 + $b2*(x-50) + $b3*0*(x-50) + $b4*(25-25) + $b0 ,range(age)  lco(blue) lpa(1)) ///
(function  y=$b1*1 + $b2*(x-50) + $b3*1*(x-50) + $b4*(30-25) + $b0 ,range(age)  lco(red) lpa(dash)) ///
(function  y=$b1*0 + $b2*(x-50) + $b3*0*(x-50) + $b4*(30-25) + $b0 ,range(age)  lco(blue)lpa(dash)) ///
,xtit("Age") ytit("log odds highSBP")  xline(50) yline( $b0) ///
legend(row(1) label(1 "women bmi=25")label(2 "man bmi=25") label(3 "women bmi=30")label(4 "man bmi=30") pos(6))
graph export RegDayEx4_Q3a.wmf,replace
***********************************************************
* calculation of fit for the four different persons
*********************************************************** 
generate  fit1=invlogit($b1*1 + $b2*(age-50) + $b3*1*(age-50) + $b4*(25-25) + $b0 )
label var fit1 " bmi+sex*age woman bmi=25 age vary"
generate  fit2=invlogit($b1*0 + $b2*(age-50) + $b3*0*(age-50) + $b4*(25-25) + $b0 )
label var fit2 " bmi+sex*age   man bmi=25 age vary"
generate  fit3=invlogit($b1*1 + $b2*(age-50) + $b3*1*(age-50) + $b4*(30-25) + $b0 )
label var fit3 " bmi+sex*age woman bmi=30 age vary" 
generate  fit4=invlogit($b1*0 + $b2*(age-50) + $b3*0*(age-50) + $b4*(30-25) + $b0 )
label var fit4 " bmi+sex*age   man bmi=30 age vary"
*ploting these four curves
line fit? age,sort lco(red blue red blue red) lpa( 1 1 dash dash) ///
,xtit("Age") ytit("prev high SBP")   legend(row(1) pos(6) ) 
graph export RegDayEx4_Q3b.wmf,replace


* women versus men 50 year
lincom 2.sex ,or

* women versus men 40 year
lincom 2.sex -10* 2.sex#c.age50,or

* women versus men 60 year
lincom 2.sex +10* 2.sex#c.age50,or

* risk for man 40 year bmi=27
lincom _cons-age50*10+bmi25*2
di invlogit(r(estimate))
di invlogit(r(estimate)-1.96*r(se))
di invlogit(r(estimate)+1.96*r(se))

* man and woman 40 year prob. high sbp as function of BMI
twoway  ///
(function y=invlogit($b1*1 + $b2*(40-50) + $b3*1*(40-50) + $b4*(x-25) + $b0), range(bmi) lco(red)) ///
(function y=invlogit($b1*0 + $b2*(40-50) + $b3*0*(40-50) + $b4*(x-25) + $b0), range(bmi) lco(blue)) ///
, ytit("prev high SBP") legend(label(1 "woman 40y") label(2 "man 40y"))
graph export RegDayEx4_Q3c.wmf,replace

* generate fitted 
generate fit5=invlogit($b1*1 + $b2*(40-50) + $b3*1*(40-50) + $b4*(bmi-25) + $b0)
label var fit5 " bmi+sex*age woman 40 year bmi vary"

generate fit6=invlogit($b1*0 + $b2*(40-50) + $b3*0*(40-50) + $b4*(bmi-25) + $b0 )
label var fit6 " bmi+sex*age man 40 year bmi vary"

sort bmi
line fit5 fit6 bmi,sort lco(red blue ) ///
, ytit("prev high SBP")  name(p3,replace) legend(pos(12)) ///
  xline(27) 
graph export RegDayEx4_Q3d.wmf,replace

*Q5
************************************************************************
*   cheking BMI
************************************************************************
* bmi in five groups 
xtile bmigrp5=bmi,n(5)
table bmigrp5,c(count bmi min bmi max bmi)
* bmigr5 added
logit sbphigh ib1.sex##c.age50 bmi25 i.bmigrp5
testparm i.bmigrp5
 


regeq
*sex*age man 40 year bmi vary
generate fit7=invlogit($b2*(40-50) + $b4*(bmi-25)+$b5*2.bmigrp5 + $b6*3.bmigrp5 + $b7*4.bmigrp5 + $b8*5.bmigrp5 + $b0)
label var fit7 " bmigrp5+sex*age+bmi man 40 year bmi vary"
line fit7 fit6 bmi,sort lco(red blue ) ///
, ytit("prev high SBP")  name(p3,replace) legend(pos(12)) 
  
  
************************************************************************
* BMI spline
mkspline bmisp5=bmi, cubic nk(5) disp
drop bmisp51
logit sbphigh b1.sex##c.age50 bmi bmisp5? 
testparm bmisp*
regeq

generate fit8=invlogit( $b2*(-10) + $b4*bmi + $b5*bmisp52 + $b6*bmisp53 + $b7*bmisp54 + $b0 )				  
label var fit8 " bmisp5+sex*age man 40 year bmi vary"

line fit8 fit7 fit6 bmi,sort lco(red blue )legend(pos(12)) ///
, ytit("prev high SBP")  name(p4,replace) 
graph export RegDayEx4_Q5a.wmf,replace

************************************************************************
* BMI og sex
logit sbphigh b1.sex##c.age50 bmi b1.sex#c.bmi 
************************************************************************
* BMI og age
* Age modification per year
logit sbphigh ib1.sex##c.age50 bmi25 c.age50#c.bmi25 
regeq


twoway  ///
(function y=($b0+$b2*(40-50)+$b4*(x-25)+$b5*(40-50)*(x-25)),range(bmi) ) ///
(function y=($b0+$b2*(50-50)+$b4*(x-25)+$b5*(50-50)*(x-25)),range(bmi) ) ///
(function y=($b0+$b2*(60-50)+$b4*(x-25)+$b5*(60-50)*(x-25)),range(bmi) ) ///
,xtit("BMI") ytit("log odds highSBP")  xline(25)  ///
legend(row(1) label(1 "man 40")label(2 "man 50") label(3 "man 60") pos(6))
graph export RegDayEx4_Q5b.wmf,replace
twoway  ///
(function y=invlogit($b0+$b2*(40-50)+$b4*(x-25)+$b5*(40-50)*(x-25)),range(bmi) ) ///
(function y=invlogit($b0+$b2*(50-50)+$b4*(x-25)+$b5*(50-50)*(x-25)),range(bmi) ) ///
(function y=invlogit($b0+$b2*(60-50)+$b4*(x-25)+$b5*(60-50)*(x-25)),range(bmi) ) ///
,xtit("BMI") ytit("prev highSBP")    ///
legend(row(1) label(1 "man 40")label(2 "man 50") label(3 "man 60") pos(6))
graph export RegDayEx4_Q5c.wmf,replace


* age modification in groups
xtile agegrp3=age,n(3)
table agegrp3,c(count age min age max age)

logit sbphigh ib1.sex##c.age50 c.bmi25 i.agegrp#c.bmi25 
testparm 2.agegrp3#c.bmi25 3.agegrp3#c.bmi25


log close
